﻿using System;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Infragistics.Web.Mvc;
using MvcMovie.Models.ESignManagment;

namespace MvcMovie.Controllers
{
    public class ESMController : Controller
    {
        static    int i = 0;
        //
        // GET: /ESM/
        public ActionResult Index()
        {
            return View();
        }

        [ActionName("load-ESM")]
        public ActionResult DataSetWithLoadOnDemand()
        {
            GridModel grid = GridLoadOnDemandModel();
            grid.ID = "gridLoadOnDemand";
            grid.InitialExpandDepth = 1;
            grid.LoadOnDemand = true;
            grid.DataSourceUrl = this.Url.Action("BindParent");
            grid.ColumnLayouts[0].DataSourceUrl = this.Url.Action("BindChild");
            
            return View("LoadESM",grid);
        }
        #region Grid Models
        private GridModel GridLoadOnDemandModel()
        {
          
            // Define the Categories layout
            GridModel grid = new GridModel();
            // grid.ClientEvents.Add()
            
            grid.AutoGenerateLayouts = false;
            grid.AutoGenerateColumns = false;
            grid.ExpandCollapseAnimations = false;
            grid.AnimationDuration = 1000;
            grid.ExpandTooltip = "Expand to see the documents";
            grid.CollapseTooltip = "Collapse here";
            grid.PrimaryKey = "SignerIndex";
            //grid.RenderCheckboxes = true;
            //grid.Caption = "Esigner Management";
            grid.Width = "100%";
            grid.Columns = new List<GridColumn>();
            GridColumn eSignaturegroup = new GridColumn();
            eSignaturegroup.HeaderText = "eSignature";
            eSignaturegroup.Group = new List<GridColumn>();
            grid.Columns.Add(new GridColumn() { HeaderText = "SignerIndex",Key = "SignerIndex",DataType = "number",Width = "0%",Hidden = true });
            grid.Columns.Add(new GridColumn() { HeaderText = "Signer",Key = "SignerName",DataType = "string",Width = "10%" });
            grid.Columns.Add(new UnboundColumn { HeaderText = "Begin Signing",Key = "SignatureStatus",DataType = "string",Template = "<button id=btn_${SignerIndex} class='btn' {{if ${SignatureStatus} }} disabled=disabled {{/if}}  onclick=fanxyboxOpen(${SignerIndex},${eSign})>Start</button>  ",Width = "10%" });
            //grid.Columns.Add(new GridColumn { HeaderText = "Begin Signing",Key = "SignatureStatus",DataType = "string",Template = "<input type='button' id=btn_${SignerIndex}  class='btn' onclick=fanxyboxOpen(${SignerIndex},${eSign}) value='Start' {{if ${SignatureStatus} }} disabled=disabled {{/if}}  />",Width = "10%" });
            eSignaturegroup.Width = "10%";
            bool _flag = false;
            if (!_flag) { 
            eSignaturegroup.Group.Add(new GridColumn() { HeaderText = "In Person ",Key = "eSign",DataType = "bool",Width = "10%",
                                                         Template = "{{if ${eSign} == 0}} <ul class=radio-group> <li><input id=InPerson_${SignerIndex} name=esign_${SignerIndex} enumType=InPerson type=radio checked=checked onclick=esignClick(\"InPerson\",btn_${SignerIndex}); /> <label for=InPerson_${SignerIndex}><span><span></span></span></label></li></ul> {{else}} <ul class=radio-group> <li><input id=InPerson_${SignerIndex} name=esign_${SignerIndex} enumType=InPerson type=radio onclick=esignClick(\"InPerson\",btn_${SignerIndex}); /> <label for=InPerson_${SignerIndex}><span><span></span></span></label></li></ul>  {{/if}}"
                    ,Hidden = _flag });
            eSignaturegroup.Group.Add(new GridColumn() { HeaderText = "Remote",Key = "eSign",DataType = "bool",Width = "10%",
                                                         Template = "{{if ${eSign} == 1}} <ul class=radio-group> <li><input id=Remote_${SignerIndex} name=esign_${SignerIndex} enumType=Remote type=radio checked=checked onclick=esignClick(\"Remote\",btn_${SignerIndex}); /> <label for=Remote_${SignerIndex}><span><span></span></span></label></li></ul> {{else}} <ul class=radio-group> <li><input id=Remote_${SignerIndex} name=esign_${SignerIndex} enumType=Remote type=radio onclick=esignClick(\"Remote\",btn_${SignerIndex}); /> <label for=Remote_${SignerIndex}><span><span></span></span></label></li></ul>  {{/if}}",
               Hidden = _flag });           
            grid.Columns.Add(eSignaturegroup);
            }

            grid.Columns.Add(new GridColumn() { HeaderText = "Status",Key = "SignatureStatus",DataType = "bool",Template = "{{if ${SignatureStatus} }} <span class=icon-check_mark></span> {{/if}}",Width = "5%" });
            GridColumn authenMode = new GridColumn();
            authenMode.HeaderText = "Authentication";
            authenMode.Group = new List<GridColumn>();

            //authenMode.Group.Add(new GridColumn() { HeaderText = "Type",Key = "SignerAuth",DataType = "string",Width = "15%",FormatterFunction = "function(obj) { if (!obj) return 'obj.AuthenticationMode'; return obj.EmailAddress; }" });

            //authenMode.Group.Add(new GridColumn() { HeaderText = "Type",Key = "SignerAuth",DataType ="eSignature",Width = "15%",FormatterFunction = GetAuthiticationMode() });
            authenMode.Group.Add(new UnboundColumn() { HeaderText = "Type",Key = "SignerAuth",DataType = "eSignature",Width = "15%",FormatterFunction = "lookupAuthiticationMode" });
            authenMode.Group.Add(new GridColumn() { HeaderText = "Email Address",Key = "SignerAuth",Template = "${SignerAuth.EmailAddress}",DataType = "string",Width = "15%" });
            authenMode.Group.Add(new GridColumn() { HeaderText = "Details",Key = "SignerAuth",Template = "${SignerAuth.Details}",DataType = "string",Width = "15%" });
            grid.Columns.Add(authenMode);
            //grid.Columns.Add(new GridColumn() { HeaderText = "Authentication Mode",Key = "SignerAuth",Template = GetAuthiticationTemplate(),DataType = "string",Width = "15%" });


            // Define the Products layout
            GridColumnLayoutModel layout = new GridColumnLayoutModel();
            layout.Key = "SessionDocuments";
            layout.ForeignKey = "SignerIndex";
            layout.PrimaryKey = "DocumentIndex";
            //layout.Width = "500";
            layout.AutoGenerateColumns = false;
            layout.Columns.Add(new GridColumn() { HeaderText = "Document Index",Key = "DocumentIndex",DataType = "number",Width = "10%",Hidden = true });
            layout.Columns.Add(new GridColumn() { HeaderText = "Signer Index",Key = "SignerIndex",DataType = "number",Width = "10%",Hidden = true });
            layout.Columns.Add(new GridColumn() { HeaderText = "Document Name",Key = "DocumentName",DataType = "string",Width = "40%" });
            layout.Columns.Add(new GridColumn() { HeaderText = "Preview",Key = "PdfUrl",DataType = "string",Width = "10%", Template = "<a class='preview fancybox' data-fancybox-type='iframe' id='preview' href='${PdfUrl}' target='_blank'> <span class='icon-preview table_icons'/>  </a>" });
            #region "Commented"
            //grid.Columns.Add(new UnboundColumn { HeaderText = "Begin Signing",Key = "Start",DataType = "string",Width = "10%", Template = "<input type=button value='Start' {{if !${SignatureStatus} }} disabled=disabled {{/if}}")});
            //grid.Columns.Add(new UnboundColumn { HeaderText = "Begin Signing",Key = "Start",DataType = "string",Width = "10%",FormatterFunction = SetSignStatus(" + $(SignatureStatus) + " )});
            //grid.Columns.Add(new UnboundColumn { HeaderText = "Begin Signing",Key = "Start",DataType = "string",Width = "10%",Template = "<input type=button onclick=fanxyboxOpen(${SignerIndex},${eSign}) value=Start />" });
            // grid.Columns.Add(new UnboundColumn { HeaderText = "Begin Signing",Key = "SignatureStatus",DataType = "string",Width = "10%",FormatterFunction = SetSignStatus() });
            //eSignaturegroup.Group.Add(new GridColumn("In Person","eSign","bool",Template="<input type='radio' checked='setFlag(${eSign})' />"));
            //eSignaturegroup.Group.Add(new GridColumn() { HeaderText = "In Person",Key = "eSign",DataType = "bool",Width = "10%",Template = "<input type='radio' checked='${eSign}' /> " });
            //eSignaturegroup.Group.Add(new GridColumn() { HeaderText = "Remote",Key = "eSign",DataType = "bool",Width = "10%",Template = "<input type='radio' /> " ,FormatterFunction=GetESign("Remote") });
            //grid.Columns.Add(new GridColumn() { HeaderText = "In Person",Key = "eSign",DataType = "string",Width = "10%",Template = "<input type='radio' checked='setFlag(${eSign})' /> " });
            //grid.Columns.Add(new GridColumn() { HeaderText = "Remote",Key = "eSign",DataType = "string",Width = "10%",Template = "<input type='radio' checked='setFlag(${eSign})' /> " });
            //grid.Columns.Add(new GridColumn() { HeaderText = "Status",Key = "SignatureStatus",DataType = "bool",Width = "5%",Format = "checkbox", Template="<label class='checkbox'><input type='checkbox' name='test'/> <span></span></label>" });
            //layout.Features.Add(new GridResponsive()
            //{
            //    EnableVerticalRendering = false,
            //    ColumnSettings = new List<ResponsiveColumnSetting>() { 
            //        new ResponsiveColumnSetting() { ColumnKey = "DocumentIndex", Classes = "ui-hidden-phone ui-hidden-tablet" },
            //        new ResponsiveColumnSetting() { ColumnKey = "DocumentName", Classes = "ui-hidden-phone ui-hidden-tablet" },
            //        new ResponsiveColumnSetting() { ColumnKey = "PdfUrl", Classes = "ui-hidden-phone ui-hidden-tablet" }
            //    }
            //});
            #endregion
            //add the MultiColumnHeader features
            grid.Features.Add(new GridMultiColumnHeaders()
            {
                Inherit = true
            });
            layout.Width = "100%";
            grid.ColumnLayouts.Add(layout);

            GridPaging paging = new GridPaging();
            paging.Type = OpType.Remote;
            paging.Inherit = true;
            paging.PageSize = 5;
            grid.Features.Add(paging);
            //attach clientside events
            //grid.AddClientEvent("filllookupAuthenticationListModeLookup","filllookupAuthenticationListModeLookup(lookupAuthenticationList)");
           // grid.Columns.RemoveAt(0);
            //added for editing
            var Updating = new GridUpdating();
           
            Updating.EnableAddRow = false;
            Updating.EnableDeleteRow = false;
            //Set this mode for editing, cell,row, none and RowEditTemplate
            Updating.EditMode = GridEditMode.Cell;
            //apply it to child layouts
            Updating.Inherit = false;
            var colUpdateSettings = new List<ColumnUpdatingSetting>();

                              
           //Set settings for SignerName
            ColumnUpdatingSetting ColumnUpdatingSettingForSigner = new ColumnUpdatingSetting();
            ColumnUpdatingSettingForSigner.ColumnKey = "SignerName";
            ColumnUpdatingSettingForSigner.ReadOnly = true;
            colUpdateSettings.Add(ColumnUpdatingSettingForSigner);

            //Set settings for SignatureStatus
            ColumnUpdatingSetting ColumnUpdatingSettingForSignatureStatus = new ColumnUpdatingSetting();
            ColumnUpdatingSettingForSignatureStatus.ColumnKey = "SignatureStatus";
            ColumnUpdatingSettingForSignatureStatus.ReadOnly = true;
            colUpdateSettings.Add(ColumnUpdatingSettingForSignatureStatus);

            //Set settings for eSignGroup
            ColumnUpdatingSetting ColumnUpdatingSettingForeSignGroup = new ColumnUpdatingSetting();
            ColumnUpdatingSettingForeSignGroup.ColumnKey = "eSign";
            ColumnUpdatingSettingForeSignGroup.ReadOnly = true;
            colUpdateSettings.Add(ColumnUpdatingSettingForeSignGroup);

            //Set settings for AuthenticationType

            ColumnUpdatingSetting columnUpdatingSettingForAuthenticationType = new ColumnUpdatingSetting();
            columnUpdatingSettingForAuthenticationType.ColumnKey = "SignerAuth";
            columnUpdatingSettingForAuthenticationType.EditorType = ColumnEditorType.Combo;
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            columnUpdatingSettingForAuthenticationType.EditorOptions = String.Format("valueKey: 'id', textKey: 'Type', dataSource: {0}",serializer.Serialize(GetAuthenticationTypes()));
            colUpdateSettings.Add(columnUpdatingSettingForAuthenticationType);

            //columnUpdatingSettingForAuthenticationType.ComboEditorOptions.Mode = ComboMode.DropDown;
            //columnUpdatingSettingForAuthenticationType.ComboEditorOptions.EnableClearButton = true;
            //columnUpdatingSettingForAuthenticationType.ComboEditorOptions.DropDownOnFocus = true;
            //columnUpdatingSettingForAuthenticationType.ComboEditorOptions.ShowDropDownButton = true;

           
            //columnUpdatingSettingForAuthenticationType.ColumnIndex = 6;
            //columnUpdatingSettingForAuthenticationType.ColumnKey = "SignerAuth";
            		//grid.Columns[5].Group[2].Template[0]	36 '$'	char

            //ColumnUpdatingComboEditorOptions cmbAuthType = new ColumnUpdatingComboEditorOptions()
            //{
            //    DropDownOnFocus = true,
            //    ShowDropDownButton = false,
            //    TextKey = "Type",
            //    ValueKey = "id",    
            //    FilteringType = ComboFilteringType.Local,
            //    ID = "cmbAuthType",
            //    Mode = ComboMode.DropDown,
            //    DataSource = GetAuthenticationTypes().AsQueryable()

            //};

            //columnUpdatingSettingForAuthenticationType.ComboEditorOptions = cmbAuthType;
            //columnUpdatingSettingForAuthenticationType.Validation = true;
          
           

            Updating.ColumnSettings.AddRange(colUpdateSettings);

            grid.Features.Add(Updating);
            //var Selection = new GridSelection() { MultipleCellSelectOnClick = false, Mode = SelectionMode.Row,Persist = true };
            //grid.Features.Add(Selection);
            //var cellMerging = new GridCellMerging();
            //cellMerging.InitialState = CellMergingInitialState.Merged;
            //cellMerging.Inherit = true;
            //grid.Features.Add(cellMerging);
            //grid.AddClientEvent("filllookupAuthenticationListModeLookup","filllookupAuthenticationListModeLookup(lookupAuthenticationList)");
            //grid.ClientEvents.Add("filllookupAuthenticationListModeLookup","filllookupAuthenticationListModeLookup(lookupAuthenticationList)");
            return grid;
        }
        #endregion // Grid Models

        private List<AuthType> GetAuthenticationTypes()
        {
            return EsignData.GetAuthenticationTypes();
        }
        private static string SetSignStatus()
        {
                var sb = new StringBuilder();
                sb.Append(" function(obj){");
                sb.Append(" if (obj){return '<input id=btnStart onclick= javascript:fanxyboxOpen(); type=button class=btn value=Start />';}");
                sb.Append(" else if  (!obj){ return '<input  type=button  class=btn disabled=disabled value=Start />';} ");
                //sb.Append(" if (obj == true){return '<input type=button onclick=fanxyboxOpen('${SignerIndex},${eSign}') value='${SignatureStatus}' />';}");
                //sb.Append(" else if  (obj != true){ return '<input type=button  class=btn disabled=disabled value=Start />';} ");
                sb.Append("} ");
                return sb.ToString();          
        }
        private static string SetSignStatus(string signerStatus)
        {
            string btn = "<input type=button onclick= javascript:fanxyboxOpen(${SignerIndex}) value=Start />";
            if (!string.IsNullOrEmpty(signerStatus))
            {

                if (Convert.ToBoolean(signerStatus)) { btn = "<input type=button onclick=fanxyboxOpen(${SignerIndex},${eSign}) value=Start />"; };
                if (!Convert.ToBoolean(signerStatus)) { btn = "<input type=button onclick=fanxyboxOpen(${SignerIndex},${eSign}) disabled=disabled value=Start />"; };

                //var sb = new StringBuilder();
                //sb.Append(" function(obj){");
                //sb.Append(" if (obj.SignatureStatus){return '<input type= button   value=Start />';}");
                //sb.Append(" else if  (!obj.SignatureStatus){ return '<input type=button  disabled=disabled value=Start />';} ");
                //sb.Append("} ");
                //return sb.ToString();
            }
            return btn;
        }
        private static string GetAuthiticationMode()
        {
            var sb = new StringBuilder();
            sb.Append(" function(obj){");
            sb.Append(" if (obj.AuthenticationMode == 0 ){return 'Email';}");
            sb.Append(" else if  (obj.AuthenticationMode == 1 ){ return 'Password';} ");
            sb.Append(" else if  (obj.AuthenticationMode == 2 ){ return 'KBA';} ");
            sb.Append("} ");
            return sb.ToString();
            //return " function(obj){if (obj.AuthenticationMode == 0 ){ return 'Email';} else if  (obj.AuthenticationMode == 1 ){ return 'Password'}}";
            ////return @" functionr(obj) {if (!obj) return 'None'; return (${SignerAuth.AuthenticationMode} == 0 ){return 'Email';}} </script></div>";
            //return "<div style='float: left;padding:1px;'>${SignerAuth.EmailAddress}</div> <div style='float: left; padding-right: 1px;' >${SignerAuth.Details}</div> <div style='float: left; padding-right: 1px;'>${SignerAuth.AuthenticationMode}</div>";
        }
        private  string GetESign(string eSign)
        {
            var sb = new StringBuilder();
            sb.Append(" function(obj){");
          //  sb.Append("_counter = _counter + 1; console.log('_counter = ' + _counter);");
            //sb.Append(" if (obj == null ){return '<input type='radio' />';}");
            if (eSign.Equals("InPerson"))
            {
                sb.Append(" if (obj == 0 ){return ' <ul class=radio-group> <li><input id=\"InPerson_' + _counter + '\" name=\"esign_' + _counter + '\" enumType=InPerson type=radio checked=checked onclick=esignClick(\"InPerson\",\"btn_'+ _counter + '\"); /> <label for=\"InPerson_' + _counter + '\"><span><span></span></span></label></li></ul>';}");
                sb.Append(" if (obj == 1 ){return '<ul class=radio-group> <li><input id=\"InPerson_' + _counter + '\" name=\"esign_' + _counter + '\" type=radio enumType=InPerson onclick=esignClick(\"InPerson\",\"btn_'+ _counter + '\");  /><label for=\"InPerson_' + _counter + '\"><span><span></span></span></label></li></ul>';}");
            }
            else if (eSign.Equals("Remote"))
            {
                //sb.Append("_counter = _counter + 1; console.log('_counter = ' + _counter);");
                sb.Append(" if  (obj == 1 ){ ");
                sb.Append(" var str = '<ul class=radio-group> <li><input id=\"Remote_' + _counter + '\"  name=\"esign_' + _counter + '\"  type=radio enumType=Remote checked=checked onclick=esignClick(\"Remote\",\"btn_'+ _counter + '\"); /><label for=\"Remote_' + _counter  + '\"><span><span></span></span></label></li></ul>';");
                 //sb.Append("  $('\"#btn_'+ _counter + '\").hide();");
                sb.Append("_counter = _counter + 1; ");
                sb.Append(" return str; }");
                sb.Append(" if  (obj == 0 ){ ");
                sb.Append(" var str = '<ul class=radio-group> <li><input id=\"Remote_' + _counter + '\"  name=\"esign_' + _counter + '\"  type=radio enumType=Remote onclick=esignClick(\"Remote\",\"btn_'+ _counter + '\"); /><label for=\"Remote_' + _counter  + '\"><span><span></span></span></label></li></ul>';");
               
                sb.Append("_counter = _counter + 1; ");
                sb.Append(" return str; }");
                //sb.Append(" if (obj == 0 ){ return '<ul class=radio-group> <li><input id=\"Remote_'+ _counter  + '\"  name=\"esign_' + _counter  + '\" type=radio  /><label for=\"Remote_' + _counter  + '\"><span><span></span></span></label></li></ul>';}");
                //sb.Append("_counter = _counter + 1; console.log('_counter = ' + _counter);");
            };
            // sb.Append(" else if  (obj.Authenticationode == 2 ){ return 'KBA';} ");
           // sb.Append("_counter = _counter + 1; console.log('_counter = ' + _counter);");
            sb.Append("} ");
           
            return sb.ToString();
            //return " function(obj){if (obj.AuthenticationMode == 0 ){ return 'Email';} else if  (obj.AuthenticationMode == 1 ){ return 'Password'}}";
            ////return @" functionr(obj) {if (!obj) return 'None'; return (${SignerAuth.AuthenticationMode} == 0 ){return 'Email';}} </script></div>";
            //return "<div style='float: left;padding:1px;'>${SignerAuth.EmailAddress}</div> <div style='float: left; padding-right: 1px;' >${SignerAuth.Details}</div> <div style='float: left; padding-right: 1px;'>${SignerAuth.AuthenticationMode}</div>";
        }

        private static string GetAuthiticationTemplate()
        {
            return "<div style='float: left;padding:1px;'>${SignerAuth.EmailAddress}</div> <div style='float: left; padding-right: 1px;' >${SignerAuth.Details}</div> <div style='float: left; padding-right: 1px;'>${SignerAuth.AuthenticationMode}</div>";
        }
        public JsonResult BindParent()
        {
            GridModel model = GridLoadOnDemandModel();           
            model.DataSource = EsignData.GetSignerRepository().AsQueryable();
           return model.GetData();
            //var r = EsignData.GetSignerRepository().AsQueryable();
            //List<SignerInformation> si = EsignData.GetSignerRepository();
            //var res = Json(si,JsonRequestBehavior.AllowGet);            
        }


        public JsonResult BindChild(string path,string layout)
        {
            GridModel model = GridLoadOnDemandModel();
            model.DataSource = EsignData.GetDocumentsRepository().AsQueryable();
            return model.GetData(path,layout);
        }
    }
}